VERSION 5.00
Begin VB.Form frmDDECommander 
   Caption         =   "DDE Commander"
   ClientHeight    =   855
   ClientLeft      =   585
   ClientTop       =   810
   ClientWidth     =   5850
   LinkTopic       =   "Form1"
   ScaleHeight     =   855
   ScaleWidth      =   5850
   Begin VB.ComboBox cmbCommand 
      Height          =   315
      Left            =   60
      TabIndex        =   3
      Top             =   480
      Width           =   4455
   End
   Begin VB.CommandButton btnExecute 
      Caption         =   "Execute"
      Default         =   -1  'True
      Height          =   315
      Left            =   4560
      TabIndex        =   2
      Top             =   480
      Width           =   1215
   End
   Begin VB.TextBox txtOutput 
      Height          =   315
      Left            =   60
      TabIndex        =   1
      Top             =   60
      Width           =   4455
   End
   Begin VB.CommandButton btnConnect 
      Caption         =   "Connect"
      Height          =   315
      Left            =   4560
      TabIndex        =   0
      Top             =   60
      Width           =   1215
   End
End
Attribute VB_Name = "frmDDECommander"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub btnConnect_Click()
    ' Establish a connection with the VI
    Dim dblTaskID As Double
    
    On Error GoTo btnConnect_ClickErrorHandler
    
    With txtOutput
        .LinkMode = vbLinkNone
        .LinkTopic = "VI|VI"
        .LinkItem = "txtOutput"
        .LinkMode = vbLinkAutomatic
    End With
    
    Exit Sub
'_________________________
btnConnect_ClickErrorHandler:

    ' Handle run-time DDE errors
    Select Case Err.Number
    Case 282    ' No foreign application responded to a DDE initiate
        dblTaskID = Shell("Vi.exe", vbNormalFocus)
        If dblTaskID > 0& Then
            Resume    ' Try again
        Else
            MsgBox "Error.  Could not start the VI"
        End If
    Case 293    ' DDE method invoked with no channel open
        MsgBox "Error.  Please turn the VI On before establishing a DDE connection."
    Case Else
        MsgBox "Error " & CStr(Err.Number) & " on Connect.  " & Err.Description
    End Select
End Sub

Private Sub btnExecute_Click()
    ' Send a command to the VI
    On Error GoTo btnExecuteErrorHandler
    
    txtOutput.LinkExecute cmbCommand.Text
    
    Exit Sub
'___________________________
btnExecuteErrorHandler:
    
    Select Case Err.Number
    Case 293    ' DDE method invoked with no channel open.
        MsgBox "Error. Is the VI running?  The DDE channel is closed."
    Case Else
        MsgBox "Error " & CStr(Err.Number) & ": " & Err.Description
    End Select
End Sub

Private Sub Form_Load()
    ' Fill the ComboBox with VI commands for convenience.
    With cmbCommand
        .AddItem "Analyze"
        .AddItem "Abort"
        .AddItem "Pause"
        .AddItem "Resume"
        .AddItem "Off"
    End With
End Sub

Private Sub txtOutput_LinkError(LinkErr As Integer)
    ' Notify user of any DDE-related errors
    Dim strMsg As String
    
    Select Case LinkErr
    Case vbDDESourceClosed
        strMsg = "Error. The DDE VI Commander attempted to continue after the VI closed."
    Case vbTooManyLinks
        strMsg = "Error. All VI DDE links are in use."
    End Select
    
    MsgBox strMsg
End Sub
