VERSION 5.00
Begin VB.Form frmParserTest 
   Caption         =   "Parser Test"
   ClientHeight    =   1290
   ClientLeft      =   1635
   ClientTop       =   2610
   ClientWidth     =   9360
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1290
   ScaleWidth      =   9360
   Begin VB.ComboBox cmbParseString 
      Height          =   315
      Left            =   1260
      TabIndex        =   4
      Top             =   120
      Width           =   7995
   End
   Begin VB.TextBox txtOutput 
      Height          =   285
      Left            =   1260
      TabIndex        =   2
      Top             =   900
      Width           =   7995
   End
   Begin VB.CommandButton btnParse 
      Caption         =   "Parse"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1260
      TabIndex        =   0
      Top             =   480
      Width           =   1815
   End
   Begin VB.Label lblOutput 
      Alignment       =   1  'Right Justify
      Caption         =   "Output:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   1095
   End
   Begin VB.Label lblParseString 
      Alignment       =   1  'Right Justify
      Caption         =   "Parse String:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   180
      Width           =   1095
   End
End
Attribute VB_Name = "frmParserTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim mParser As New clsParser            ' A new instance of the parser class.
Public mColNumbers As New Collection    ' Most recent collection of parsed numbers


Private Sub Form_Load()
    mParser.Separators = ",/"               ' Initialize separators.
    mParser.Terminators = vbCr & ";"        ' Initialize terminators.
    
    ' Put several examples in the combo box.
    cmbParseString.AddItem "12, -34, 56.7" & vbCr
    cmbParseString.AddItem "12, 34.5, -56; "
    cmbParseString.AddItem "12, 34, 56,-7,8,9     99999; "
    cmbParseString.AddItem "12/-34/56;"
    cmbParseString.AddItem "12/,-34/56.7;"
    cmbParseString.AddItem "ERROR 123" & vbCr
    cmbParseString.AddItem "ERROR " & vbCr
    cmbParseString.AddItem "ERR 123;"
    cmbParseString.AddItem "ERROR 123/" & vbCr
    cmbParseString.AddItem "ERROR -123456789" & vbCr
    cmbParseString.AddItem "ERROR -12345.6789" & vbCr
    
End Sub

Private Sub btnParse_Click()
    Dim strResult As String, strStatement As String
    Dim intCount As Integer, I As Integer
    
    txtOutput.Text = ""         ' Clear the output TextBox
                                ' Parse the statement.
    mParser.ParseString = cmbParseString.Text
    If ParseStatement(strStatement) = True Then
                                ' Collect and display the result.
        strResult = strStatement & " - Values: " & CStr(mColNumbers.Item(1))
        
        intCount = mColNumbers.Count
        For I = 2 To intCount
            strResult = strResult & "," & CStr(mColNumbers.Item(I))
        Next I
        
        txtOutput.Text = strResult
    End If
    
End Sub

Function ParseStatement(strStatement As String) As Boolean
    ' Parse the given string.
    Dim intErrorCode As Long
    
    ParseStatement = False      ' Assume failure. Clear the collection.
    Do While mColNumbers.Count > 0: mColNumbers.Remove 1: Loop
    
    ' Look for an 'ERROR' keyword.
    If mParser.ParseLiteral("ERROR") = True Then
        ' Skip any white space
        mParser.ParseWhitespace
        
        ' Look for an error code.
        If mParser.ParseInteger(intErrorCode) = True Then
            ' Put the error code on the class number collection.
            mColNumbers.Add intErrorCode
        Else
            mParser.SyntaxError "Expected an Error code"
            Exit Function
        End If
        
        ' Look for a terminator.
        If mParser.ParseTerminator() = False Then
            mParser.SyntaxError "Expected a terminator"
            Exit Function
        End If
        
        ' If all goes well, indicate that an ERROR statement was parsed.
        strStatement = "Error"
        ParseStatement = True
        Exit Function
        
    ' If an ERROR keyword was not found then look for a number sequence.
    ElseIf mParser.ParseNumberSequence(mColNumbers) = True Then
        ' Look for a terminator.
        If mParser.ParseTerminator() = False Then
            mParser.SyntaxError "Expected a terminator"
            Exit Function
        End If
        
        ' If all goes well, indicate that a measurement was parsed.
        strStatement = "Measurement"
        ParseStatement = True
        Exit Function
        
    ' Otherwise indicate a syntax error.
    Else
        strStatement = ""
        mParser.SyntaxError "Expected a Measurement or Error statement"
        Exit Function
    End If
    
End Function
