VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmSheet 
   Caption         =   "VB Spreadsheet"
   ClientHeight    =   2880
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8625
   LinkTopic       =   "Form1"
   ScaleHeight     =   2880
   ScaleWidth      =   8625
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtEdit 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      Height          =   255
      Left            =   360
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   2400
      Width           =   1335
   End
   Begin MSFlexGridLib.MSFlexGrid grdSheet 
      Height          =   2715
      Left            =   60
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   60
      Width           =   8415
      _ExtentX        =   14843
      _ExtentY        =   4789
      _Version        =   393216
      Rows            =   10
      Cols            =   8
      FocusRect       =   2
      ScrollBars      =   0
      AllowUserResizing=   3
      Appearance      =   0
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditUndo 
         Caption         =   "&Undo"
         Shortcut        =   ^Z
      End
      Begin VB.Menu mnuEditSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditCut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin VB.Menu mnuEditCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuEditPaste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu mnuEditClear 
         Caption         =   "Cl&ear"
      End
      Begin VB.Menu mnuSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditFind 
         Caption         =   "&Find ..."
         Shortcut        =   ^F
      End
      Begin VB.Menu mnuEditFindAgain 
         Caption         =   "Find A&gain"
         Shortcut        =   ^G
      End
      Begin VB.Menu mnuSep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditFillDown 
         Caption         =   "Fill &Down"
         Shortcut        =   ^D
      End
      Begin VB.Menu mnuEditFillRight 
         Caption         =   "Fill &Right"
         Shortcut        =   ^R
      End
   End
End
Attribute VB_Name = "frmSheet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents mSheet As clsSheet
Attribute mSheet.VB_VarHelpID = -1

Private Sub Form_Load()
    ' Create and initialize the Sheet object.
    Dim I As Integer, J As Integer
    
    Set mSheet = New clsSheet           ' Create the new class
    
    With mSheet
        Set .Grid = grdSheet            ' Assign MSFlexGrid and TextBox controls
        Set .EditBox = txtEdit
        
        .Rows = 8                       ' Set the sheet size
        .Cols = 12
        
        For I = 1 To 8                  ' Set row titles
            .RowTitle(I) = Chr$(I + 64)
        Next I
        
        For J = 1 To 12                 ' Set column titles
            .ColTitle(J) = CStr(J)
            .ColWidth(J) = 600
            .ColFormat(J) = "0.000"
        Next J
        
        For I = 1 To 8                  ' Initialize to random data
            For J = 1 To 12
                .Cell(I, J) = Rnd
            Next J
        Next I
        
    End With
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuEditUndo_Click()
    mSheet.CancelEdit
End Sub

Private Sub mnuEditCut_Click()
    mSheet.CopyToClipboard
    mSheet.ClearSelectedCells
End Sub

Private Sub mnuEditCopy_Click()
    mSheet.CopyToClipboard
End Sub

Private Sub mnuEditPaste_Click()
    mSheet.PasteFromClipboard
End Sub

Private Sub mnuEditClear_Click()
    Screen.MousePointer = vbHourglass
    mSheet.ClearSelectedCells
    Screen.MousePointer = vbDefault
End Sub

Private Sub mnuEditFind_Click()
    ' Find the given substring
    Dim strValue As String
    
    strValue = Trim(InputBox("Find what: ", "Find", strValue))
    If strValue = "" Then Exit Sub
    
    Screen.MousePointer = vbHourglass
    If mSheet.Find(strValue) = False Then
        Screen.MousePointer = vbDefault
        MsgBox "Not found", vbOKOnly, "Find"
    End If
    Screen.MousePointer = vbDefault
    
End Sub

Private Sub mnuEditFindAgain_Click()
    ' Find the given pattern again.
    
    Screen.MousePointer = vbHourglass
    If mSheet.Find() = False Then
        Screen.MousePointer = vbDefault
        MsgBox "Not Found", vbOKOnly, "Find"
    End If
    Screen.MousePointer = vbDefault

End Sub

Private Sub mnuEditFillDown_Click()
    Screen.MousePointer = vbHourglass
    mSheet.FillDown
    Screen.MousePointer = vbDefault
End Sub

'Private Sub mSheet_CellChanged(intRow As Integer, intCol As Integer)
'    Debug.Print "Cell Changed: Row=" & CStr(intRow) & ", Col=" & CStr(intCol)
'End Sub

Private Sub mnuEditFillRight_Click()
    Screen.MousePointer = vbHourglass
    mSheet.FillRight
    Screen.MousePointer = vbDefault
End Sub

