VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StripChart"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' A constant defining the number of points the class should plot
Const mConNumPoints As Integer = 101

' Array that holds StripChart values
Private mSngChartVals(0 To mConNumPoints - 1) As Single

' Index in the array that is the current starting point
Private mIntStartIndex As Integer

' A reference to the PictureBox on which to draw the StripChart
Private WithEvents mPct As PictureBox
Attribute mPct.VB_VarHelpID = -1

Public Sub AddPoint(sngPoint As Single)
    ' Add a point to the rotating point array

    ' Add point to next position in array
    mSngChartVals(mIntStartIndex) = sngPoint
    
    ' Update starting point for drawing the chart
    mIntStartIndex = mIntStartIndex + 1
    If mIntStartIndex > mConNumPoints - 1 Then mIntStartIndex = 0
    
    ' Redraw the StripChart
    DrawChart
    
End Sub

Private Sub DrawChart()
    ' Draw the StripChart
    Dim I As Integer, sngX As Single, sngXIncrement As Single
    
    ' Reset the background
    mPct.Cls
    
    ' Draw chart values
    sngX = 0#
    sngXIncrement = 1# / CSng(mConNumPoints - 1)
    mPct.DrawWidth = 3
    
    For I = mIntStartIndex To mConNumPoints - 1
        mPct.Line (sngX, 0#)-(sngX, mSngChartVals(I)), vbRed
        sngX = sngX + sngXIncrement
    Next I
    
    For I = 0 To mIntStartIndex - 1
        mPct.Line (sngX, 0#)-(sngX, mSngChartVals(I)), vbRed
        sngX = sngX + sngXIncrement
    Next I
    
End Sub

Public Property Set PictureBox(pctBox As PictureBox)
    ' Set and configure the PictureBox on which the strip chart will be drawn.
    Set mPct = pctBox
    
    ' Set the coordinates of the PictureBox.
    'mPct.Scale (-0.2, 1.2)-(1.2, -0.2)
    With mPct
        .ScaleLeft = -0.2
        .ScaleWidth = 1.4
        .ScaleTop = 1.2
        .ScaleHeight = -1.4
    End With
    
    ' Draw the axes and save background.  Draw initial chart.
    SetBackground
    DrawChart
    
End Property

Private Sub SetBackground()
    ' Draw the axes and save in the PictureBox Picture property
    mPct.AutoRedraw = True      ' Begin persistent graphic
    mPct.BackColor = vbWhite    ' Clear
    
    ' Draw outline
    mPct.Line (0, 0)-(1#, 1#), vbBlack, B
    
    ' Draw ticks and labels
    mPct.Line (0#, 0#)-(-0.02, 0#), vbBlack
    
    mPct.FontSize = 12
    mPct.CurrentX = -2# * mPct.TextWidth("0.0")
    mPct.CurrentY = -mPct.TextHeight("0.0") * 0.5
    mPct.Print "0.0"
    
    mPct.Line (0#, 1#)-(-0.02, 1#), vbBlack
    mPct.CurrentX = -2# * mPct.TextWidth("1.0")
    mPct.CurrentY = 1# - mPct.TextHeight("1.0") * 0.5
    mPct.Print "1.0"
    
    ' Store the background image in the Picture property
    mPct.Picture = mPct.Image
    mPct.AutoRedraw = False
    
End Sub

Private Sub mPct_Paint()
    DrawChart           ' Redraw the StripChart when needed
End Sub
