VERSION 5.00
Begin VB.Form frmXmitFormats 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Transmission Formats"
   ClientHeight    =   855
   ClientLeft      =   2070
   ClientTop       =   2490
   ClientWidth     =   4590
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   855
   ScaleWidth      =   4590
   ShowInTaskbar   =   0   'False
   Begin VB.ComboBox cmbLineTerm 
      Height          =   315
      Left            =   1920
      TabIndex        =   3
      Top             =   480
      Width           =   1395
   End
   Begin VB.ComboBox cmbTokenSep 
      Height          =   315
      Left            =   1920
      TabIndex        =   2
      Top             =   120
      Width           =   1395
   End
   Begin VB.CommandButton btnOK 
      Caption         =   "OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   3420
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton btnCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   3420
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label lblLineTerm 
      Alignment       =   1  'Right Justify
      Caption         =   "Line Terminator:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   480
      Width           =   1695
   End
   Begin VB.Label lblTokenSep 
      Alignment       =   1  'Right Justify
      Caption         =   "Token Separator:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   1695
   End
End
Attribute VB_Name = "frmXmitFormats"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Transmission start/end constants
Const mNone As Integer = 1
Const mSTX As Integer = 2           ' Start of text
Const mETX As Integer = 3           ' End of text
Const mEOT As Integer = 4           ' End of transmission
Const mSpace As Integer = 5         ' Space
Const mComma As Integer = 6         ' Comma
Const mTab As Integer = 7           ' Tab
Const mCRLF As Integer = 8          ' Carriage Return, Linefeed
Const mCR As Integer = 9            ' Carriage Return
Const mLF As Integer = 10           ' Linefeed

Private Sub InitializeForm()
    ' Initialize the combo boxes
    
    ' Token Separators
    With cmbTokenSep
        .Clear
        .AddItem "<Comma>":         .ItemData(.NewIndex) = mComma
        .AddItem "<Tab>":           .ItemData(.NewIndex) = mTab
        .AddItem "<Space>":         .ItemData(.NewIndex) = mSpace
        .ListIndex = 0              ' Default to <Comma>
    End With
    
    ' Line Terminators
    With cmbLineTerm
        .Clear
        .AddItem "<CR>":            .ItemData(.NewIndex) = mCR
        .AddItem "<LF>":            .ItemData(.NewIndex) = mLF
        .AddItem "<CR><LF>":        .ItemData(.NewIndex) = mCRLF
        .ListIndex = 0              ' Default to <CR><LF>
    End With

End Sub

Private Sub ResetFormatEffectors()
    ' Reset Main Form Transmission Format Effectors
    
    ' Token Separators
    With cmbTokenSep
        If .ListIndex < 0 Then      ' Not selected or new entry
            frmMain.TokenSep = Trim(.Text)
        
        Else                        ' Provided option selected
            Select Case .ItemData(.ListIndex)
            Case mComma             ' Comma
                frmMain.TokenSep = ","
            Case mTab               ' Tab
                frmMain.TokenSep = vbTab
            Case mSpace             ' Space
                frmMain.TokenSep = " "
            End Select
            
        End If
    End With
    
    ' Line Terminators
    With cmbLineTerm
        If .ListIndex < 0 Then      ' Not selected or new entry
            frmMain.LineTerm = Trim(.Text)
        
        Else                        ' Provided option selected
            Select Case .ItemData(.ListIndex)
            Case mCRLF              ' <CR><LF>
                frmMain.LineTerm = vbCrLf
            Case mCR                ' <CR>
                frmMain.LineTerm = vbCr
            Case mLF                ' <LF>
                frmMain.LineTerm = vbLf
            End Select
            
        End If
    End With

End Sub

Private Sub btnCancel_Click()
    Hide
End Sub

Private Sub btnOK_Click()
    ' Reset Format Effectors strings in Main Form
    ResetFormatEffectors
    Hide
End Sub

Private Sub Form_Load()
    InitializeForm
End Sub

